<div class="card card-outline card-primary">
	<div class="card-header">
		<h3 class="card-title">List of Repairs</h3>
		<div class="card-tools">
			<a href="./?page=repairreceived/manage_repairreceived" class="btn btn-primary btn-sm btn-flat"><i class="fa fa-plus"></i> Add Repair</a>
		</div>
	</div>
	<div class="card-body">
		<div class="container-fluid">
        <div class="container-fluid">
			<table class="table table-hover table-striped table-bordered">
				<colgroup>
					<col width="5%">
					<col width="15%">
					<col width="15%">
					<col width="30%">
					<col width="10%">
					<col width="15%">
					<col width="10%">
					<col width="10%">
					<col width="10%">
					<col width="10%">
					<col width="10%">
					<col width="10%">
					<col width="10%">
					<col width="10%">
					<col width="10%">
				</colgroup>
				<thead>
					<tr class="table-warning">
						<th>SL.No</th>
						<th>Received Date</th>
						<th>Complain ID</th>
						<th>Customer Info</th>
						<th>RMA Status</th>
						<th>Deliverey Date</th>
						<th>Assigned Engineer Name</th>
						<th>Repair Eng Status</th>
						<th>Repair Date</th>
						<th>Repair TAT</th>
						<th>Total Bill</th>
						<th>Issuing Branch</th>
						<th>Issuing Branch Incharge</th>
						<th>Action</th>
					</tr>
				</thead>
				<tbody>
					<?php 
						$i = 1;
						$qry = $conn->query("SELECT r.*,CONCAT(c.firstname,', ',c.contact,' ',c.lastname,' ',c.email,' ',c.middlename) as client from `repair_list` r inner join client_list c on r.client_id = c.id order by unix_timestamp(r.`date_created`) desc ");
						while($row = $qry->fetch_assoc()):
					?>
						<tr class="table-info">
							<td class="text-center"><?php echo $i++; ?></td>
							<td class=""><?php echo date("F d-m-y g:i a",strtotime($row['date_created'])) ?></td>
							<td><?php echo ($row['code']) ?></td>
							<td class=""><p class="truncate-1"><?php echo ucwords($row['client']) ?></p></td>
							<td class="text-center">
								<?php 
									switch ($row['status']){
										case 0:
											echo '<span class="rounded-pill badge badge-secondary">In-Progress</span>';
											break;
										case 1:
											echo '<span class="rounded-pill badge badge-primary">Approved</span>';
											break;
										case 2:
											echo '<span class="rounded-pill badge badge-info">Under Diagnosis</span>';
											break;
										case 3:
											echo '<span class="rounded-pill badge badge-warning">QC Pending</span>';
											break;
										case 4:
											echo '<span class="rounded-pill badge badge-success">QC Passed</span>';
											break;
										case 5:
											echo '<span class="rounded-pill badge badge-success">Repair OK</span>';
											break;
                                        case 6:
                                            echo '<span class="ml-4 rounded-pill badge badge-danger">Same Back Delivery</span>';
                                            break;
                                        case 7:
                                            echo '<span class="rounded-pill badge badge-danger">Repair Fail</span>';
                                            break;
                                        case 8:
                                            echo '<span class="rounded-pill badge badge-success">Delivered Done</span>';
                                            break;
                                        case 9:
                                            echo '<span class="rounded-pill badge badge-danger">Delivered-Payment Due</span>';
                                            break;            
									}
								?>
							</td>


							<td ><?php echo date( "F d-m-y g:i a",strtotime($row['deliverey_date'])) ?></td>


							<td class="text-center">
								<?php 
									switch ($row['attempt_engineer_name']){
										case 26:
											echo '<span class="rounded-pill badge badge-warning">None</span>';
											break;
										case 14:
											echo '<span class="rounded-pill badge badge-secondary">SK-SAYED HOSAIN-(MP)</span>';
											break;
										case 15:
											echo '<span class="rounded-pill badge badge-primary">Alomgiar NITC-(MP)</span>';
											break;
										case 16:
											echo '<span class="rounded-pill badge badge-info">Saiful Islam-(MP)</span>';
											break;
										case 17:
											echo '<span class="rounded-pill badge badge-warning">Pulak Sukul-Panel Dept-(Banani)</span>';
											break;	
										case 25:
											echo '<span class="rounded-pill badge badge-warning">AQ Tusher-MSI Dept-(Banani)</span>';
											break;
										case 32:
											echo '<span class="rounded-pill badge badge-warning">Tanvir Hossen-MSI Dept-(Banani)</span>';
											break;
										case 33:
											echo '<span class="rounded-pill badge badge-warning">SK-Alomgir-Acer Dept-(Banani)</span>';
											break;
											case 35:
											echo '<span class="rounded-pill badge badge-warning">SHAWON_ACER Dept-(Banani)</span>';
											break;
										case 34:
											echo '<span class="rounded-pill badge badge-warning">Md Hridoy Howlader-MSI Dept-(Banani)</span>';
											break;
										case 36:
											echo '<span class="rounded-pill badge badge-warning">MD Shoel Rana-Inch MSI Dept-(Banani)</span>';
											break;	
										case 27:
											echo '<span class="rounded-pill badge badge-warning">MD.GIASH UDDIN HOWLADER</span>';
											break;		        
									}
								?>
								</td>


								<td class="text-center">
								<?php 
									switch ($row['repair_eng_status']){
										
										
										case 2:
											echo '<span class="rounded-pill badge badge-info">Under Diagnosis</span>';
											break;
										case 3:
											echo '<span class="rounded-pill badge badge-warning">QC Pending</span>';
											break;
										case 4:
											echo '<span class="rounded-pill badge badge-success">QC Passed</span>';
											break;
										case 5:
											echo '<span class="rounded-pill badge badge-success">Repair Complete</span>';
											break;
                                      
                                        case 7:
                                            echo '<span class="rounded-pill badge badge-danger">Repair Fail</span>';
                                            break;	        
									}
								?>
								</td>
								
								<td ><?php echo date( "F d-m-y g:i a",strtotime($row['repair_date'])) ?></td>
								
								<td ><?php
                                $date_created=date_create($row['date_created']);
                                $repair_date=date_create($row['repair_date']);
                                $diff=date_diff($date_created,$repair_date);
                                echo $diff->format(" %a days");
                                ?></td>

								<td class=""><p class="badge bg-primary" >BDT- <?php echo ucwords($row['total_amount']) ?></p></td>
								

								<td class="text-center">
								<?php 
									switch ($row['issuing_branch']){
										case 28:
											echo '<span class="rounded-pill badge badge-warning">None</span>';
											break;
										case 10:
											echo '<span class="rounded-pill badge badge-secondary">(Dhaka) Multiplan Center Br</span>';
											break;
										case 11:
											echo '<span class="rounded-pill badge badge-primary">(Dhaka) Banani Br</span>';
											break;
										case 12:
											echo '<span class="rounded-pill badge badge-info">(Sylhet) Westworld Shopping Complex Br</span>';
											break;
										case 13:
											echo '<span class="rounded-pill badge badge-warning">(Dhaka) Banani Head Office</span>';
											break;		        
									}
								?>
								</td>



								<td class="text-center">
								<?php 
									switch ($row['issuing_branch_incharge']){
										case 29:
											echo '<span class="rounded-pill badge badge-secondary">(None)</span>';
											break;
										case 18:
											echo '<span class="rounded-pill badge badge-secondary">Tanjina Urmi-RMA-(MP)</span>';
											break;
										case 19:
											echo '<span class="rounded-pill badge badge-primary">Alomgiar-NITC-(MP)</span>';
											break;
										case 20:
											echo '<span class="rounded-pill badge badge-info">Saiful Islam-ENG-(MP)</span>';
											break;
										case 21:
											echo '<span class="rounded-pill badge badge-warning">Yousuf Ashru-RMA-(Banani)</span>';
											break;

										case 22:
											echo '<span class="rounded-pill badge badge-warning">Shibly Nomani-RMA-(Banani)</span>';
											break;
										case 23:
											echo '<span class="rounded-pill badge badge-warning">zahidul Islam-RMA-(Banani)</span>';
											break;
										case 24:
											echo '<span class="rounded-pill badge badge-warning">MD.GIASH UDDIN HOWLADER (MP/BAN)</span>';
											break;
										case 30:
											echo '<span class="rounded-pill badge badge-warning">Samaed-RMA-(Sylhet)</span>';
											break;		
												        
									}
								?>
								</td>


							<td align="center">
								 <button type="button" class="btn btn-flat btn-default btn-sm dropdown-toggle dropdown-icon" data-toggle="dropdown">
				                  		Action
				                    <span class="sr-only">Toggle Dropdown</span>
				                  </button>
				                  <div class="dropdown-menu" role="menu">
				                    <a class="dropdown-item" href="./?page=repairreceived/view_details_repairreceived&id=<?php echo $row['id'] ?>" data-id=""><span class="fa fa-window-restore text-gray"></span> View</a>
				                    <div class="dropdown-divider"></div>
				                    <a class="dropdown-item" href="./?page=delivered/manage_delivered&id=<?php echo $row['id'] ?>" data-id="<?php echo $row['id'] ?>"><span class="fas fa-shipping-fast text-green"></span>Delivered</a>
				                    <div class="dropdown-divider"></div>
				                  </div>
							</td>
						</tr>
					<?php endwhile; ?>
				</tbody>
			</table>
		</div>
		</div>
	</div>
</div>
<script>
	$(document).ready(function(){
		$('.delete_data').click(function(){
			_conf("Are you sure to delete this repair permanently?","delete_repair",[$(this).attr('data-id')])
		})
		$('.table td,.table th').addClass('py-1 px-2 align-middle')
		$('.table').dataTable({
            columnDefs: [
                { orderable: false, targets: 5 }
            ],
        });
	})
	function delete_repair($id){
		start_loader();
		$.ajax({
			url:_base_url_+"classes/Master.php?f=delete_repair",
			method:"POST",
			data:{id: $id},
			dataType:"json",
			error:err=>{
				console.log(err)
				alert_toast("An error occured.",'error');
				end_loader();
			},
			success:function(resp){
				if(typeof resp== 'object' && resp.status == 'success'){
					location.reload();
				}else{
					alert_toast("An error occured.",'error');
					end_loader();
				}
			}
		})
	}
</script>